Attribute VB_Name = "MakeRSS"
Option Explicit

'Erstellt aus <http://www.msxfaq.net/sonst/logbuch.htm#rss> einen RSS-Feed.
Sub MakeRSS()

'    Const grssinput As String = "sonst/logbuch.htm"
'    Const grssoutput As String = "newsletter/msxfaq.xml"
'    Const grsstemplate As String = "newsletter/rss-template.xml"
'    Const grssmaxitems As Integer = 10
        
    Dim doc As New MSXML2.DOMDocument50              'Vorlage einlesen.
    Call Logging(0, "MakeRSS: gestartet")
    doc.load ActiveWeb.LocateFile(grsstemplate).url
    
    Dim channel As MSXML2.IXMLDOMElement                 '"channel"-Element lokalisieren.
    Set channel = doc.selectSingleNode("/rss/channel")
      
    Dim processedItems As Integer
    processedItems = 0
    
    Dim pw As PageWindowEx
    Set pw = ActiveWeb.LocatePage(grssinput, fpPageViewNoWindow)
      
    Dim li As FPHTMLLIElement
    Dim rssItem As MSXML2.IXMLDOMElement
    Dim title As MSXML2.IXMLDOMElement
    Dim description As MSXML2.IXMLDOMElement
    Dim link As MSXML2.IXMLDOMElement
      
    For Each li In pw.Document.all.Item("rss").all.tags("li")               ' alle LI Eintrge durchlaufen
        processedItems = processedItems + 1
        Call Logging(3, "MakeRSS: Erstelle RSS Eintrag " + Str(processedItems))
        If processedItems > grssmaxitems Then Exit For
      
        Set rssItem = doc.createElement("item")
        Set title = doc.createElement("title")
        Set description = doc.createElement("description")
        Set link = doc.createElement("link")
        If InStr(li.innerText, vbCrLf) = 0 Then                             'Aufzhlung nur einzeilig
            title.Text = li.innerText
            description.Text = li.innerText
        Else
            title.Text = Left(li.innerText, InStr(li.innerText, vbCrLf) - 1)  'Aufzhlung mehrzeilig
            description.Text = Mid(li.innerText, InStr(li.innerText, vbCrLf) + 2)
        End If
        
        rssItem.appendChild title
        rssItem.appendChild description
        
        If li.all.tags("a").Length > 0 Then                                 'Manchmal gibt es keinen Link.
            link.Text = MakeAbs(gbaseURL & "/" & grssinput, li.all.tags("a")(0).getAttribute("href"))
            rssItem.appendChild link
        End If
            
        channel.appendChild rssItem
    Next
    pw.Close
    Call Logging(0, "MakeRSS: speichern")
    doc.Save ActiveWeb.LocateFile(grssoutput).url                          'XML-Dokument speichern.
    
    
    Dim pwRss As PageWindowEx                                               'XML schn reformatieren
    Set pwRss = ActiveWeb.LocatePage(grssoutput)
    CommandBars.FindControl(ID:=9250).Execute
    pwRss.Save
    pwRss.Close

    Call Logging(0, "MakeRSS: beendet")
End Sub

