Attribute VB_Name = "pagework"
Option Explicit

'Durchluft alle Seiten und fgt ggf. Mens ein.
Sub PageWork()

'   Const gpageworkTitleprefix = "MSXFAQ.DE"

    Dim wf As WebFile
    Dim pw As PageWindowEx
    Dim Log As String
    Dim count, breadcount, menucount, titlecount, changed As Integer

    changed = 0
    count = 0
    breadcount = 0
    menucount = 0
    titlecount = 0
  
    For count = 0 To ActiveWeb.AllNavigationNodes.count - 1
    'For count = 0 To ActiveWeb.AllFiles.count - 1
        Set wf = ActiveWeb.AllNavigationNodes.Item(count).file
        Log = count & "/" & ActiveWeb.AllNavigationNodes.count & " " & MakeRel(ActiveWeb.url, wf.url) & " , "
        
        Set pw = wf.Edit(fpPageViewNoWindow)
        Log = Log & " Loaded"
        
'BREADCRUMB einbauen, wenn sie sich gendert haben.
        Dim breadcrumb As DispIHTMLTemplateRegionElement
        Dim breadcrumbHtml As String
        Set breadcrumb = pw.Document.templateRegions.Item("breadcrumb")
        If Not breadcrumb Is Nothing Then
            breadcrumbHtml = MakeBreadcrumb("", wf)
            If Not TrimmedStringsMatch(breadcrumbHtml, breadcrumb.innerHTML) Then
                breadcrumb.innerHTML = breadcrumbHtml
                breadcount = breadcount + 1
            End If
        End If
            
'MENU einbauen, wenn sie sich gendert haben.
        Dim menu As DispIHTMLTemplateRegionElement
        Dim menuHtml As String
        Set menu = pw.Document.templateRegions.Item("menu")
        If Not menu Is Nothing Then
            menuHtml = MakeMenu(wf)
            If Not TrimmedStringsMatch(menuHtml, menu.innerHTML) Then
                menu.innerHTML = menuHtml
                menucount = menucount + 1
            End If
        End If
        
' Einpflegen der bersetzungslinks
        Dim Translate As DispIHTMLTemplateRegionElement
        Dim TranslateHtml As String
        Set Translate = pw.Document.templateRegions.Item("Translate")
        If Not Translate Is Nothing Then
            TranslateHtml = "<a href=""http://" & MakeRel(ActiveWeb.url, wf.url) & """>" _
                            & "<img border=""0"" src=""" & MakeRel(wf.url, ActiveWeb.url & "/images/lang-de.gif") & """ alt=""Back to DE""></a>" _
                            & "<a href=""http://translate.google.com/translate?hl=en&amp;sl=de&amp;u=" _
                            & "http://" & MakeRel(ActiveWeb.url, wf.url) & """>" _
                            & "<img border=""0"" src=""" & MakeRel(wf.url, ActiveWeb.url & "/images/lang-en.gif") & """ alt=""Translate to EN""></a>" _
                            & "<a href=""http://translate.google.com/translate?hl=fr&amp;sl=de&amp;u=" _
                            & "http://" & MakeRel(ActiveWeb.url, wf.url) & """>" _
                            & "<img border=""0"" src=""" & MakeRel(wf.url, ActiveWeb.url & "/images/lang-fr.gif") & """ alt=""Translate to FR""></a>"
            If Not TrimmedStringsMatch(TranslateHtml, Translate.innerHTML) Then
                Translate.innerHTML = TranslateHtml
            End If
        End If
        
' Titel anpassen
        If InStr(pw.Document.title, gpageworkTitleprefix) <> 1 Then
            pw.Document.title = gpageworkTitleprefix & " - " & pw.Document.title
            Call Main.Logging(0, "Titel korrigiert in " & pw.Document.title)
            titlecount = titlecount + 1
        End If
        
' fehlende ALT-Tags bei Bildern addieren
        Dim img As FPDispIHTMLImgElement
        For Each img In pw.Document.templateRegions.Item("content").all.tags("img")                ' alle img Eintrge durchlaufen
            If InStr(img.outerHTML, "alt=") = 0 Then
                img.alt = ""
                Call Logging(2, "Pagework IMGAlt: leeres ALT Tag addiert bei " & MakeRel(ActiveWeb.url, pw.Document.url) & "Image:" & img.src)
            End If
        Next

' fehlende Title-Tags bei Hyperlinks addieren
        Dim anchor As FPHTMLAnchorElement
        
        For Each anchor In pw.Document.templateRegions.Item("content").all.tags("a")                ' alle img Eintrge durchlaufen
            If anchor.title = "" Then
                    anchor.title = anchor.Href
                Call Logging(2, "Pagework Anchortitle: ADD bei " & MakeRel(ActiveWeb.url, pw.Document.url) & "Link:" & anchor.Href)
            End If
        Next
        
        
' Externe Links besonders kennzeiochnen
'Dim pw As PageWindow
'Set pw = ActivePageWindow
'Dim anchorTag As IHTMLAnchorElement
'For Each anchorTag In pw.Document.all.tags("A")
'If IsExternalLink(anchorTag.Href) Then
  'anchorTag.className = "Offsite"
'End If
'Next
'
        
        
' Tabel Cleanup      <table border="1" cellspacing="1" width="90%" id="table2">
' suchen nach <font color="#FFFFFF">
' &amp;  korrigieren in <a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=0cd7f34b&DisplayLang=en">

' <span lang="EN-GB">
'   <p class="MsoNormal">
' <font SIZE="2"> zumindest suchen
' <p class="MsoNormal" style="text-indent: -14.15pt; margin-left: 1.0cm">
' Code: Suchen und ersetzen:  Qxxxxxx durch KBxxxxxx und SPAN-Tag

        
' Keywords in keywordArray aufnehmen

        If Not pw.Document.templateRegions.Item("Keyword") Is Nothing Then
            Dim keywordlist As String
            Dim Keyword As Variant
            keywordlist = pw.Document.templateRegions.Item("keyword").innerText
            keywordlist = Replace(keywordlist, ",", " ")  ' Ersetze Kommata als Trenner
            keywordlist = Replace(keywordlist, ";", " ")  ' Ersetze Semikolon als Trenner
            keywordlist = Replace(keywordlist, """", " ") ' Ersetze mehrfache leerzeichen als Trenner
            For Each Keyword In Split(keywordlist, " ") ' Space  ist trenner der Keywordliste
                Call Logging(5, "Pagework Keyword: " & Keyword)
                'ReDim Preserve arrkeywords(2, 1) 'UBound(arrkeywords, 2) + 1
                'arraykeywords(0, 1) = keyword
                'arraykeywords(1, 1) = wf.title
                'arraykeywords(2, 1) = wf.url
                

'                Set keywordnode = keywordxml.selectSingleNode("/keywords/keyword[@id=""" & keyword & """]") 'Keyword selectieren
 '               If keywordnode Is Nothing Then
  '                  keywordnode = keywordxml.createNode(1, "/keywords/keyword[@id=""" & keyword & """]", "")
   '             End If
                '    Set keywordnode = keywordxml.createNode(NODE_ELEMENT, "url", keyword)
                '    keywordxml.appendChild keywordnode
            Next
        Else
            Call Logging(2, "Pagework NO Keyword:")
        End If
        
'Nur speichern, wenn ntig.
        If pw.IsDirty Then
            pw.Save
            Log = Log & " Saved - Done"
            changed = changed + 1
        Else
            Log = Log & " Unchanged - Done"
        End If
        pw.Close
        
        Call Main.Logging(2, "Pagework: " + Log)
    Next
    
    
' Copy Default.htm to index.htm due some webservers are using index.htm as default page
    Call Logging(0, "Pagework: COPY index.htm nach default.htm")

'    Set wf = ActiveWeb.LocateFile(ActiveWeb.url & "/default.htm")
'    wf.Delete
'    Set wf = ActiveWeb.LocateFile(ActiveWeb.url & "/index.htm")
'    wf.Copy (ActiveWeb.url & "/default.htm")
    
    Call Logging(0, "Pagework: Menu:" & menucount & "  breadcrumb:" & breadcount & " Title changed:" & titlecount)
    Call Logging(0, "Pagework: Total:" & count & "  Totalchanged:" & changed)
End Sub

Function GetParents(ByVal node As NavigationNode) As Collection
'Liefert eine Liste der Knoten, die in der Navigationsansicht ber der Datei stehen.

    Dim col As New Collection
    Dim currentNode As NavigationNode
    
    Set currentNode = node
    Do
        col.Add currentNode
        Set currentNode = currentNode.Parent
    Loop Until currentNode Is ActiveWeb.RootNavigationNode
    Set GetParents = col
End Function

Function MakeMenu(ByVal ActiveFile As WebFile) As String
'Erzeugt ein umfangreiches Men in HTML

    If ActiveFile.NavigationNode Is Nothing Then Exit Function
        'Seiten, die nicht in der Navigationsansicht plaziert sind, bergehen.
    Dim ancestors As Collection
    Set ancestors = GetParents(ActiveFile.NavigationNode)
    MakeMenu = MakeTree(ActiveWeb.HomeNavigationNode.Children, ancestors, ActiveFile)
End Function

'Erzeugt eine Ebene des umfangreichen Mens.
Function MakeTree(ByVal Nodes As NavigationNodes, ByVal ancestors As Collection, ByVal ActiveFile As WebFile)

    If Nodes.count = 0 Then Exit Function
    
    Dim temp As String
    temp = "<ul>"
    
    Dim node As NavigationNode
    For Each node In Nodes
        If node.InNavBars = True Then    'FC nur Seiten in der Navigation einschliessen
            temp = temp & "<li>" & AnchorElement(node.file, ActiveFile)
            'Ggf. weiter verzweigen.
            If node.Children.count > 0 Then
'                temp = temp & "+"   ' Meneintrge mit Unterseiten gesondert kennzeichnen
                temp = temp & "<img border=""0"" src=""" & MakeRel(ActiveFile.url, ActiveWeb.url & "/images/submenu.gif") & """ alt=""Untermenue"">"
            End If
            Dim ancestor As NavigationNode
            For Each ancestor In ancestors
                If node Is ancestor Then
                    temp = temp & MakeTree(node.Children, ancestors, ActiveFile)  ' Unterseiten generieren
                    Exit For
                End If
            Next
            temp = temp & "</li>"
        End If
    Next
    
' Alter Code 28. Feb 2006
'
'    For Each node In Nodes
'        If node.InNavBars = True Then    'FC nur Seiten in der Navigation einschliessen
'            temp = temp & "<li>" & AnchorElement(node.file, ActiveFile)
'        End If
'        'Ggf. weiter verzweigen.
'        Dim ancestor As NavigationNode
'        For Each ancestor In ancestors
'            If node Is ancestor Then
'                temp = temp & MakeTree(node.Children, ancestors, ActiveFile)  ' Unterseiten generieren
'                Exit For
'            End If
'        Next
'        If node.InNavBars = True Then    'FC nur Seiten in der Navigation einschliessen
'            temp = temp & "</li>"
'        End If
'    Next
    
    
    
    temp = temp & "</ul>"
    MakeTree = temp
End Function

'Erzeugt ein Breadcrumb-Men.
Function MakeBreadcrumb(ByVal Delimiter As String, ByVal ActiveFile As WebFile) As String

    'Seiten, die nicht in der Navigationsansicht plaziert sind, bergehen.
    If ActiveFile.NavigationNode Is Nothing Then Exit Function
    
    Dim temp As String
    
    Dim currentNode As NavigationNode
    Set currentNode = ActiveFile.NavigationNode
    Do
       'Jeweils eine Ebene erzeugen.
        temp = Delimiter & AnchorElement(currentNode.file, ActiveFile) & " " & temp
        
        'Sonderbehandlung fr Seiten, die auf einer Ebene mit der Homepage liegen, bspw. die Sitemap.
        If currentNode.Parent Is ActiveWeb.RootNavigationNode And Not currentNode Is ActiveWeb.HomeNavigationNode Then
            Set currentNode = ActiveWeb.HomeNavigationNode
        Else
            'In der Navigationsstruktur eine Stufe nach oben.
            Set currentNode = currentNode.Parent
        End If
    Loop Until currentNode Is ActiveWeb.RootNavigationNode
    MakeBreadcrumb = temp
End Function

'Gibt den HTML-Code fr ein "a"-Element zurck.
Function AnchorElement(ByVal TargetFile As WebFile, ByVal SourceFile As WebFile) As String

  Dim temp As String

  Dim self As Boolean
  If TargetFile Is SourceFile Then     'Keine Links auf dieselbe Seite erzeugen.
    self = True
  End If

  If Not self Then   'Das ffnende Tag.
    temp = temp & "<a href='" & MakeRel(SourceFile.url, TargetFile.url) & "'>"
  End If

  temp = temp & HTMLEncode(TargetFile.NavigationNode.Label)  'Elementinhalt.

  If Not self Then    'Schlieendes Tag.
    temp = temp & "</a>"
  End If

  AnchorElement = temp

End Function
    
Function HTMLEncode(ByVal s As String) As String
'Verndert einen String so, da er gefahrlos in Attributwerten oder Elementinhalt verwendet werden kann.

    s = Replace(s, "&", "&amp;")
    s = Replace(s, "<", "&lt;")
    s = Replace(s, ">", "&gt;")
    s = Replace(s, """", "&quot;")
    s = Replace(s, "'", "&#39;") 'Fr den Apostroph gibt es in HTML keine Entity.
    HTMLEncode = s
End Function
    
Function TrimmedStringsMatch(ByVal s1 As String, ByVal s2 As String) As Boolean
'Testet, ob zwei Strings identisch sind, wenn Leerraumzeichen nicht bercksichtigt werden.

    s1 = RemoveWhitespace(s1)
    s2 = RemoveWhitespace(s2)
    
    If StrComp(s1, s2, vbTextCompare) = 0 Then
        TrimmedStringsMatch = True
    Else
        TrimmedStringsMatch = False
    End If
    
End Function
    
Function RemoveWhitespace(ByVal s As String) As String
'Entfernt Leerraumzeichen aus Strings.

    s = Replace(s, " ", "")
    s = Replace(s, vbCr, "")
    s = Replace(s, vbLf, "")
    s = Replace(s, vbTab, "")
    RemoveWhitespace = s
End Function
